<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: MST_TipoAfectacionIGV.xml */
/* Generado: 2022-01-20 22:55:24 */

/* Mantenimiento de los registros de la tabla MST_TipoAfectacionIGV */
abstract class BaseMST_TipoAfectacionIGVDP extends MST_TipoAfectacionIGVBV
{
    /* Constructor ( Establece los valores desde un objeto MST_TipoAfectacionIGVBN ) */
    public function __construct( MST_TipoAfectacionIGVBN $o_MST_TipoAfectacionIGVBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_MST_TipoAfectacionIGVBN ) )
        {
            $this->setByBN( $o_MST_TipoAfectacionIGVBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto MST_TipoAfectacionIGVBN */
    public function setByBN( MST_TipoAfectacionIGVBN $o_MST_TipoAfectacionIGVBN )
    {
        if ( !is_null( $o_MST_TipoAfectacionIGVBN->getTipoIgvId() ) )
        {
            $this->setTipoIgvId( $o_MST_TipoAfectacionIGVBN->getTipoIgvId() );
        }
        if ( !is_null( $o_MST_TipoAfectacionIGVBN->getDescripcion() ) )
        {
            $this->setDescripcion( $o_MST_TipoAfectacionIGVBN->getDescripcion() );
        }
        if ( !is_null( $o_MST_TipoAfectacionIGVBN->getCodigoSunat() ) )
        {
            $this->setCodigoSunat( $o_MST_TipoAfectacionIGVBN->getCodigoSunat() );
        }
        if ( !is_null( $o_MST_TipoAfectacionIGVBN->getCodigoProv() ) )
        {
            $this->setCodigoProv( $o_MST_TipoAfectacionIGVBN->getCodigoProv() );
        }
        if ( !is_null( $o_MST_TipoAfectacionIGVBN->getCodigoTributo() ) )
        {
            $this->setCodigoTributo( $o_MST_TipoAfectacionIGVBN->getCodigoTributo() );
        }
        if ( !is_null( $o_MST_TipoAfectacionIGVBN->getEstado() ) )
        {
            $this->setEstado( $o_MST_TipoAfectacionIGVBN->getEstado() );
        }
        if ( !is_null( $o_MST_TipoAfectacionIGVBN->getFechaRegistro() ) )
        {
            $this->setFechaRegistro( $o_MST_TipoAfectacionIGVBN->getFechaRegistro() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_MST_TipoAfectacionIGVFN = new MST_TipoAfectacionIGVFN();
        $o_MST_TipoAfectacionIGVBN = $o_MST_TipoAfectacionIGVFN->selectByPk( $this->getTipoIgvId() );
        if ( is_null( $o_MST_TipoAfectacionIGVBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO MST_TipoAfectacionIGV ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getTipoIgvId() ) )
            {
                $s_SQLQuery1 .= $s_Separator."TipoIgvId";
                $s_SQLQuery2 .= $s_Separator."".$this->getTipoIgvId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescripcion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Descripcion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDescripcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCodigoSunat() ) )
            {
                $s_SQLQuery1 .= $s_Separator."CodigoSunat";
                $s_SQLQuery2 .= $s_Separator."'".$this->getCodigoSunat()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCodigoProv() ) )
            {
                $s_SQLQuery1 .= $s_Separator."CodigoProv";
                $s_SQLQuery2 .= $s_Separator."'".$this->getCodigoProv()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCodigoTributo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."CodigoTributo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getCodigoTributo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Estado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaRegistro() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaRegistro";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaRegistro()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE MST_TipoAfectacionIGV SET ";
            $s_Separator = "";
            if ( !is_null( $this->getDescripcion() ) )
            {
                $s_SQLQuery .= $s_Separator."Descripcion = '".$this->getDescripcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCodigoSunat() ) )
            {
                $s_SQLQuery .= $s_Separator."CodigoSunat = '".$this->getCodigoSunat()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCodigoProv() ) )
            {
                $s_SQLQuery .= $s_Separator."CodigoProv = '".$this->getCodigoProv()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCodigoTributo() ) )
            {
                $s_SQLQuery .= $s_Separator."CodigoTributo = '".$this->getCodigoTributo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery .= $s_Separator."Estado = '".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaRegistro() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaRegistro = '".$this->getFechaRegistro()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  TipoIgvId = ".$this->getTipoIgvId().";";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM MST_TipoAfectacionIGV WHERE  TipoIgvId = ".$this->getTipoIgvId().";";
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        return true;
    }

}
?>